#ifndef RESOURCE_H
#define RESOURCE_H

#define APP_NAME                    "VNC Viewer"
#define APP_NAME_LENGTH             10

#define IDICON_VIEWWIN            1
#define IDICON_FILE               2
#define IDICON_FOLDER             3
#define IDICON_FILE_HIDDEN        4
#define IDICON_FOLDER_HIDDEN      5
#define IDICON_ENCRYPTED          6
#define IDICON_UNENCRYPTED        7
#define IDPTR_DEFPTR              8

// Messages
#define IDM_INVALID_DEST_HOST     0
#define IDM_INVALID_HOST          1
#define IDM_FORGET_QUESTION       2
#define IDM_INI_OPEN_ERROR        3
#define IDM_TIP_HOST              4
#define IDM_TIP_DESTHOST          5
#define IDM_TIP_LISTEN_DESTHOST   6
#define IDM_TIP_SCALE             7
#define IDM_TIP_CHARSET           8
#define IDM_TIP_ALL_ENCODINGS     9
#define IDM_TIP_SEL_ENCODINGS    10
#define IDM_TIP_COMPRESS_LEVEL   11
#define IDM_TIP_QUALITY_LEVEL    12
#define IDM_TIP_IFADDR           13
#define IDM_TIP_PORT             14
#define IDM_SW_INVALID           15
#define IDM_SW_NO_VALUE          16
#define IDM_SW_NO_HOST           17
#define IDM_SW_INVALID_VALUE     18
#define IDM_SW_INVALID_DEPTH     19
#define IDM_SW_INVALID_ENC       20
#define IDM_SW_UNKNOWN           21
#define IDM_ALREADY_BINDED       22
#define IDM_CHAT_CLOSED          23
#define IDM_CHAT_NOT_DETECTED    24
#define IDM_OVERWRITE            25
#define IDM_LMKDIR_FAIL          26
#define IDM_RMKDIR_FAIL          27
#define IDM_RFILE_DELETE_FAIL    28
#define IDM_QUERY_RDELETE        29
#define IDM_QUERY_LRMOVE         30
#define IDM_RENAME_FAIL          31
#define IDM_RECV_READ_FAIL       32
#define IDM_RECV_WRITE_FAIL      33
#define IDM_SEND_WRITE_FAIL      34
#define IDM_SEND_READ_FAIL       35
#define IDM_RDIRFILEREPLACE      36
#define IDM_OVERWRITERDIR        37
#define IDM_QUERY_LDELETE        38
#define IDM_LFILE_DELETE_FAIL    39
#define IDM_QUERY_RLMOVE         40
#define IDM_LRENAME_FAIL         41
#define IDM_PERMISSION_DENIED    42
#define IDM_AUTHFAILED           43

// Strings
#define IDS_NEW_CONNECTION        0
#define IDS_VIEW_ONLY             1
#define IDS_SEND_CAD              2
#define IDS_SEND_CTRL_ESC         3
#define IDS_SEND_ALT_ESC          4
#define IDS_SEND_ALT_TAB          5
#define IDS_CHAT                  6
#define IDS_FILE_TRANSFER         7
#define IDS_SCREENSHOT            8
#define IDS_CONNECT               9
#define IDS_LISTEN               10
#define IDS_LISTENING            11
#define IDS_WAIT_SERVER          12
#define IDS_NAME                 13
#define IDS_SIZE                 14
#define IDS_DATE                 15
#define IDS_TIME                 16
#define IDS_ATTRIBUTES           17
#define IDS_OK                   18
#define IDS_CANCEL               19
#define IDS_SKIP                 20
#define IDS_ALL                  21
#define IDS_NONE                 22
#define IDS_YES                  23
#define IDS_NO                   24
#define IDS_OP_RLCOPY            25
#define IDS_OP_RLMOVE            26
#define IDS_OP_RDELETE           27
#define IDS_OP_LRCOPY            28
#define IDS_OP_LRMOVE            29
#define IDS_OP_LDELETE           30
#define IDS_DRIVE_REMOVABLE      31
#define IDS_DRIVE_LOCAL          32
#define IDS_DRIVE_CDDVD          33
#define IDS_DRIVE_TAPE           34
#define IDS_DRIVE_CD             35
#define IDS_DRIVE_FLOPPY         36
#define IDS_DRIVE_VIDEO          37
#define IDS_DRIVE_REMOTE         38
#define IDS_ANY                  39
#define IDS_LOW                  40
#define IDS_HIGH                 41


// Dialogs

#define IDDLG_PROGRESS           1000
#define IDPBAR_PROGRESS          1001

#define IDDLG_PASSWORD           2500
#define IDDDLG_CREDENTIAL        2600
#define IDEF_USERNAME            2501
#define IDEF_PASSWORD            2502
#define IDST_UNENCCONN           2503
#define IDST_ENCCONN             2504

#define IDDLG_OPTIONS            3000
#define IDSB_ATTEMPTS            3001
#define IDSB_BPP                 3002
#define IDCB_REMEMBER_PSWD       3003
#define IDCB_VIEW_ONLY           3004
#define IDCB_SHARE_DESKTOP       3005
#define IDCB_NO_TLS              3006
#define IDSB_SCALE               3007
#define IDSB_DESTPORT            3008
#define IDEF_CHARSET             3009
#define IDLB_ALL_ENCODINGS       3010
#define IDPB_ENC_ADD             3011
#define IDPB_ENC_DELETE          3012
#define IDLB_SEL_ENCODINGS       3013
#define IDPB_ENC_UP              3014
#define IDPB_ENC_DOWN            3015
#define IDSLID_QUALITY           3016
#define IDSLID_COMPRESS          3017
#define IDCB_USE_AS_DEFAULT      3018
#define IDPB_UNDO                3019
#define IDPB_DEFAULT             3020

#define IDDLG_LAUNCHPAD          3500
#define IDD_NOTEBOOK             3501

#define IDDLG_PAGE_CONNECT       4000
#define IDCB_HOST                4001
#define IDPB_OPTIONS             4002
#define IDPB_FORGET              4003

#define IDDLG_PAGE_LISTEN        4500
#define IDCB_IFADDR              4501
#define IDSB_PORT                4502

#define IDDLG_FILEXFER           5000
#define IDCB_LDRIVES             5001
#define IDPB_LUPDIR              5002
#define IDPB_LROOT               5003
#define IDEF_LPATH               5004
#define IDCN_LLIST               5005
#define IDCB_RDRIVES             5006
#define IDPB_RUPDIR              5007
#define IDPB_RROOT               5008
#define IDEF_RPATH               5009
#define IDCN_RLIST               5010
#define IDMI_COPY                5011
#define IDMI_MOVE                5012
#define IDMI_MKDIR               5013
#define IDMI_DELETE              5014
#define IDMI_LDRIVE              5015
#define IDMI_RDRIVE              5016
#define IDMI_RENAME              5017
#define IDMI_REFRESH             5018
#define IDMI_OPENFOLDER          5019

#define IDDLG_FXPROGRESS         5500
#define IDST_OPERATION           5501
#define IDST_FILE                5502
#define IDST_TOTAL_SIZE          5503
#define IDPBAR_OPERATION         5504

#endif // RESOURCE_H
