/*
   The script copies the contents of the programs_ID.txt file into
   programs.txt, separating the lines with a single character 0x0A.

   ID is the language identifier specified by the command line argument:
     >programs.cmd taglang=en

   File programs.txt includes in ..\vncserver_ID.rc
*/

parse upper arg "TAGLANG="ID

parse source strSrc
parse var strSrc s1 s2 SrcFName

if ID = "" then
do
  say "Usage: " || filespec( "name", SrcFName ) || " TAGLANG=id"
  say "Where 'id' is the target language."
  exit 1
end

SrcPath = filespec( "drive", SrcFName ) || filespec( "path", SrcFName )
InFName = SrcPath || "programs_" || strip( ID ) || ".txt"
OutFName = SrcPath || "programs.txt"

ret = stream( InFName, "c", "open read" )
if ret \= "READY:" then
do
  say "Could not open " || InFName
  exit 1
end

"@if exist """ || OutFName || """ del """ || OutFName || """"

ret = stream( OutFName, "c", "open write" )
if ret \= "READY:" then
do
  call stream InFName, "c", "close"
  say "Could not create " || InFName
  exit 1
end

do while lines( InFName ) \= 0
  call charout OutFName, linein( InFName ) || x2c("0A")
end
call stream OutFName, "c", "close"
call stream InFName, "c", "close"
say "File " || OutFName || " has been created."

exit 0
